<html>
<head>
<title>Ogre::MaterialManager::Listener Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1MaterialManager.html">MaterialManager</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html">Listener</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::MaterialManager::Listener Class Reference</div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::MaterialManager::Listener" -->
<p><a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html" title="Listener on any general material events.">Listener</a> on any general material events.  
 <a href="classOgre_1_1MaterialManager_1_1Listener.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreMaterialManager_8h_source.html">OgreMaterialManager.h</a>&gt;</code></p>

<p><a href="classOgre_1_1MaterialManager_1_1Listener-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html#aa701d203c20e60133d82305454f366f5">~Listener</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Virtual destructor needed as class has virtual methods.  <a href="#aa701d203c20e60133d82305454f366f5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1Technique.html">Technique</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html#a54bc384ab1102063aa00db4c3a5f3fc4">handleSchemeNotFound</a> (unsigned short schemeIndex, const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;schemeName, <a class="el" href="classOgre_1_1Material.html">Material</a> *originalMaterial, unsigned short lodIndex, const <a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *rend)=0</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Called if a technique for a given scheme is not found within a material, allows the application to specify a <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> instance manually.  <a href="#a54bc384ab1102063aa00db4c3a5f3fc4"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p><a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html" title="Listener on any general material events.">Listener</a> on any general material events. </p>
<dl class="see"><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1MaterialManager.html#aca25d5c0aca1f6b873725265b829cf1c" title="Add a listener to handle material events.">MaterialManager::addListener</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreMaterialManager_8h_source.html#l00069">69</a> of file <a class="el" href="OgreMaterialManager_8h_source.html">OgreMaterialManager.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="aa701d203c20e60133d82305454f366f5"></a><!-- doxytag: member="Ogre::MaterialManager::Listener::~Listener" ref="aa701d203c20e60133d82305454f366f5" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html#aa701d203c20e60133d82305454f366f5">Ogre::MaterialManager::Listener::~Listener</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Virtual destructor needed as class has virtual methods. </p>

<p>Definition at line <a class="el" href="OgreMaterialManager_8h_source.html#l00073">73</a> of file <a class="el" href="OgreMaterialManager_8h_source.html">OgreMaterialManager.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a54bc384ab1102063aa00db4c3a5f3fc4"></a><!-- doxytag: member="Ogre::MaterialManager::Listener::handleSchemeNotFound" ref="a54bc384ab1102063aa00db4c3a5f3fc4" args="(unsigned short schemeIndex, const String &amp;schemeName, Material *originalMaterial, unsigned short lodIndex, const Renderable *rend)=0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1Technique.html">Technique</a>* <a class="el" href="classOgre_1_1MaterialManager_1_1Listener.html#a54bc384ab1102063aa00db4c3a5f3fc4">Ogre::MaterialManager::Listener::handleSchemeNotFound</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>schemeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&#160;</td>
          <td class="paramname"><em>schemeName</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Material.html">Material</a> *&#160;</td>
          <td class="paramname"><em>originalMaterial</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>lodIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Renderable.html">Renderable</a> *&#160;</td>
          <td class="paramname"><em>rend</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Called if a technique for a given scheme is not found within a material, allows the application to specify a <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> instance manually. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd><a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> schemes allow you to switch wholesale between families of techniques on a material. However they require you to define those schemes on the materials up-front, which might not be possible or desirable for all materials, particular if, for example, you wanted a simple way to replace all materials with another using a scheme. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This callback allows you to handle the case where a scheme is requested but the material doesn't have an entry for it. You can return a <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> pointer from this method to specify the material technique you'd like to be applied instead, which can be from another material entirely (and probably will be). Note that it is critical that you only return a <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> that is supported on this hardware; there are utility methods like <a class="el" href="classOgre_1_1Material.html#a37ae7259ce89bdc38828ea1b977bdbcf" title="Gets the best supported technique.">Material::getBestTechnique</a> to help you with this. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">schemeIndex</td><td>The index of the scheme that was requested - all schemes have a unique index when created that does not alter. </td></tr>
    <tr><td class="paramname">schemeName</td><td>The friendly name of the scheme being requested </td></tr>
    <tr><td class="paramname">originalMaterial</td><td>The material that is being processed, that didn't have a specific technique for this scheme </td></tr>
    <tr><td class="paramname">lodIndex</td><td>The material level-of-detail that was being asked for, in case you need to use it to determine a technique. </td></tr>
    <tr><td class="paramname">rend</td><td>Pointer to the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> that is requesting this technique to be used, so this may influence your choice of <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a>. May be null if the technique isn't being requested in that context. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>A pointer to the technique to be used, or NULL if you wish to use the default technique for this material </dd></dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreMaterialManager_8h_source.html">OgreMaterialManager.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:59
</p>
</body>
</html>
